var Client = require('node-rest-client').Client;
const BASE_URL = "https://api.kontist.com/api/";

module.exports = class KontistClient extends Client {

    /**
     * Return information for logged in user. (via constructor {user: "", password: ""} parameters)
     */
    getUser() {
        var me = this;
        return new Promise((resolve, reject) => {
            me.get(BASE_URL + "user", {}, (data) => resolve(data));
        });
    }

    /**
     * Return list of accounts.
     */
    getAccounts() {
        var me = this;
        return new Promise((resolve, reject) => {
            me.get(BASE_URL + "accounts", {}, (data) => resolve(data));
        });
    }

    /**
     * Return list of transactions.
     * @param number accountId
     */
    getTransactions(accountId) {
        var me = this;
        return new Promise((resolve, reject) => {
            me.get(BASE_URL + "accounts/${accountId}/transactions", { path: { accountId } }, (data) => resolve(data));
        });
    }

    /**
     * Return list of transfers.
     * @param number accountId
     */
    getTransfers(accountId) {
        var me = this;
        return new Promise((resolve, reject) => {
            me.get(BASE_URL + "accounts/${accountId}/transfer", { path: { accountId } }, (data) => resolve(data));
        });
    }


}